/**
 * DocumentRoot.java
 *
 * File generated from the medication::DocumentRoot uml Class
 * Generated by IHE - europe, gazelle team
 */
package net.ihe.gazelle.medication;

import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBElement;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElementRef;
import javax.xml.bind.annotation.XmlElementRefs;
import javax.xml.bind.annotation.XmlMixed;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import net.ihe.gazelle.gen.common.ConstraintValidatorModule;


/**
 * Description of the class DocumentRoot.
 *
 */

@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "DocumentRoot", propOrder = {
	"mixed"
})
@XmlRootElement(name = "DocumentRoot")
public class DocumentRoot implements java.io.Serializable {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	
	@XmlElementRefs({
			@XmlElementRef(name = "xmlns:prefix", type = JAXBElement.class),
			@XmlElementRef(name = "xsi:schemaLocation", type = JAXBElement.class),
			@XmlElementRef(name = "asContent", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "asDistributedProduct", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "asMedicineManufacturer", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "asSpecializedKind", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "desc", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "expirationTime", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "formCode", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "handlingCode", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "id", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "ingredient", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "medication", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "part", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "riskCode", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "stabilityTime", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "subjectOf1", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "subjectOf2", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "subjectOf3", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "subjectOf4", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class),
			@XmlElementRef(name = "subjectOf5", namespace = "urn:epsos-org:ep:medication", type = JAXBElement.class)
		})
		@XmlMixed
	public List<java.io.Serializable> mixed;
	
	/**
	 * An attribute containing marshalled element node
	 */
	@XmlTransient
	private org.w3c.dom.Node _xmlNodePresentation;
	
	
	/**
	 * Return mixed.
	 * @return mixed
	 */
	public List<java.io.Serializable> getMixed() {
		if (mixed == null) {
	        mixed = new ArrayList<java.io.Serializable>();
	    }
	    return mixed;
	}
	
	/**
	 * Set a value to attribute mixed.
	 * @param mixed.
	 */
	public void setMixed(List<java.io.Serializable> mixed) {
	    this.mixed = mixed;
	}
	
	
	
	/**
	 * Add a mixed to the mixed collection.
	 * @param mixed_elt Element to add.
	 */
	public void addMixed(java.io.Serializable mixed_elt) {
	    this.mixed.add(mixed_elt);
	}
	
	/**
	 * Remove a mixed to the mixed collection.
	 * @param mixed_elt Element to remove
	 */
	public void removeMixed(java.io.Serializable mixed_elt) {
	    this.mixed.remove(mixed_elt);
	}
	
	/**
	 * Return xMLNSPrefixMap.
	 * @return xMLNSPrefixMap
	 */
	public List<String> getXMLNSPrefixMap() {
		List<String> xMLNSPrefixMap_el = new ArrayList<String>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("xmlns:prefix")){
					xMLNSPrefixMap_el.add( (String) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return xMLNSPrefixMap_el;
	}
	
	public void addXMLNSPrefixMap(String obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<String> jobj = of.createDocumentRootXMLNSPrefixMap(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return xSISchemaLocation.
	 * @return xSISchemaLocation
	 */
	public List<String> getXSISchemaLocation() {
		List<String> xSISchemaLocation_el = new ArrayList<String>();
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("xsi:schemaLocation")){
					xSISchemaLocation_el.add( (String) ((javax.xml.bind.JAXBElement<?>)obj).getValue() );
				}
			}
		} 

	    return xSISchemaLocation_el;
	}
	
	public void addXSISchemaLocation(String obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<String> jobj = of.createDocumentRootXSISchemaLocation(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return asContent.
	 * @return asContent
	 */
	public net.ihe.gazelle.medication.COCTMT230100UVContent getAsContent() {
		net.ihe.gazelle.medication.COCTMT230100UVContent asContent_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("asContent")){
					asContent_el = (net.ihe.gazelle.medication.COCTMT230100UVContent) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return asContent_el;
				}
			}
		} 

	    return asContent_el;
	}
	
	public void addAsContent(net.ihe.gazelle.medication.COCTMT230100UVContent obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.COCTMT230100UVContent> jobj = of.createDocumentRootAsContent(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return asDistributedProduct.
	 * @return asDistributedProduct
	 */
	public net.ihe.gazelle.medication.COCTMT230100UVDistributedProduct getAsDistributedProduct() {
		net.ihe.gazelle.medication.COCTMT230100UVDistributedProduct asDistributedProduct_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("asDistributedProduct")){
					asDistributedProduct_el = (net.ihe.gazelle.medication.COCTMT230100UVDistributedProduct) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return asDistributedProduct_el;
				}
			}
		} 

	    return asDistributedProduct_el;
	}
	
	public void addAsDistributedProduct(net.ihe.gazelle.medication.COCTMT230100UVDistributedProduct obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.COCTMT230100UVDistributedProduct> jobj = of.createDocumentRootAsDistributedProduct(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return asMedicineManufacturer.
	 * @return asMedicineManufacturer
	 */
	public net.ihe.gazelle.medication.COCTMT230100UVMedicineManufacturer getAsMedicineManufacturer() {
		net.ihe.gazelle.medication.COCTMT230100UVMedicineManufacturer asMedicineManufacturer_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("asMedicineManufacturer")){
					asMedicineManufacturer_el = (net.ihe.gazelle.medication.COCTMT230100UVMedicineManufacturer) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return asMedicineManufacturer_el;
				}
			}
		} 

	    return asMedicineManufacturer_el;
	}
	
	public void addAsMedicineManufacturer(net.ihe.gazelle.medication.COCTMT230100UVMedicineManufacturer obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.COCTMT230100UVMedicineManufacturer> jobj = of.createDocumentRootAsMedicineManufacturer(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return asSpecializedKind.
	 * @return asSpecializedKind
	 */
	public net.ihe.gazelle.medication.COCTMT230100UVSpecializedKind getAsSpecializedKind() {
		net.ihe.gazelle.medication.COCTMT230100UVSpecializedKind asSpecializedKind_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("asSpecializedKind")){
					asSpecializedKind_el = (net.ihe.gazelle.medication.COCTMT230100UVSpecializedKind) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return asSpecializedKind_el;
				}
			}
		} 

	    return asSpecializedKind_el;
	}
	
	public void addAsSpecializedKind(net.ihe.gazelle.medication.COCTMT230100UVSpecializedKind obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.COCTMT230100UVSpecializedKind> jobj = of.createDocumentRootAsSpecializedKind(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return desc.
	 * @return desc
	 */
	public net.ihe.gazelle.medication.ED getDesc() {
		net.ihe.gazelle.medication.ED desc_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("desc")){
					desc_el = (net.ihe.gazelle.medication.ED) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return desc_el;
				}
			}
		} 

	    return desc_el;
	}
	
	public void addDesc(net.ihe.gazelle.medication.ED obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.ED> jobj = of.createDocumentRootDesc(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return expirationTime.
	 * @return expirationTime
	 */
	public net.ihe.gazelle.medication.IVLTS getExpirationTime() {
		net.ihe.gazelle.medication.IVLTS expirationTime_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("expirationTime")){
					expirationTime_el = (net.ihe.gazelle.medication.IVLTS) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return expirationTime_el;
				}
			}
		} 

	    return expirationTime_el;
	}
	
	public void addExpirationTime(net.ihe.gazelle.medication.IVLTS obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.IVLTS> jobj = of.createDocumentRootExpirationTime(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return formCode.
	 * @return formCode
	 */
	public net.ihe.gazelle.medication.CE getFormCode() {
		net.ihe.gazelle.medication.CE formCode_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("formCode")){
					formCode_el = (net.ihe.gazelle.medication.CE) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return formCode_el;
				}
			}
		} 

	    return formCode_el;
	}
	
	public void addFormCode(net.ihe.gazelle.medication.CE obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.CE> jobj = of.createDocumentRootFormCode(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return handlingCode.
	 * @return handlingCode
	 */
	public net.ihe.gazelle.medication.CE getHandlingCode() {
		net.ihe.gazelle.medication.CE handlingCode_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("handlingCode")){
					handlingCode_el = (net.ihe.gazelle.medication.CE) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return handlingCode_el;
				}
			}
		} 

	    return handlingCode_el;
	}
	
	public void addHandlingCode(net.ihe.gazelle.medication.CE obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.CE> jobj = of.createDocumentRootHandlingCode(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return id.
	 * @return id
	 */
	public net.ihe.gazelle.medication.II getId() {
		net.ihe.gazelle.medication.II id_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("id")){
					id_el = (net.ihe.gazelle.medication.II) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return id_el;
				}
			}
		} 

	    return id_el;
	}
	
	public void addId(net.ihe.gazelle.medication.II obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.II> jobj = of.createDocumentRootId(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return ingredient.
	 * @return ingredient
	 */
	public net.ihe.gazelle.medication.COCTMT230100UVIngredient getIngredient() {
		net.ihe.gazelle.medication.COCTMT230100UVIngredient ingredient_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("ingredient")){
					ingredient_el = (net.ihe.gazelle.medication.COCTMT230100UVIngredient) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return ingredient_el;
				}
			}
		} 

	    return ingredient_el;
	}
	
	public void addIngredient(net.ihe.gazelle.medication.COCTMT230100UVIngredient obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.COCTMT230100UVIngredient> jobj = of.createDocumentRootIngredient(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return medication.
	 * @return medication
	 */
	public net.ihe.gazelle.medication.COCTMT230100UVMedication getMedication() {
		net.ihe.gazelle.medication.COCTMT230100UVMedication medication_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("medication")){
					medication_el = (net.ihe.gazelle.medication.COCTMT230100UVMedication) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return medication_el;
				}
			}
		} 

	    return medication_el;
	}
	
	public void addMedication(net.ihe.gazelle.medication.COCTMT230100UVMedication obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.COCTMT230100UVMedication> jobj = of.createDocumentRootMedication(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return part.
	 * @return part
	 */
	public net.ihe.gazelle.medication.COCTMT230100UVPart getPart() {
		net.ihe.gazelle.medication.COCTMT230100UVPart part_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("part")){
					part_el = (net.ihe.gazelle.medication.COCTMT230100UVPart) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return part_el;
				}
			}
		} 

	    return part_el;
	}
	
	public void addPart(net.ihe.gazelle.medication.COCTMT230100UVPart obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.COCTMT230100UVPart> jobj = of.createDocumentRootPart(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return riskCode.
	 * @return riskCode
	 */
	public net.ihe.gazelle.medication.CE getRiskCode() {
		net.ihe.gazelle.medication.CE riskCode_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("riskCode")){
					riskCode_el = (net.ihe.gazelle.medication.CE) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return riskCode_el;
				}
			}
		} 

	    return riskCode_el;
	}
	
	public void addRiskCode(net.ihe.gazelle.medication.CE obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.CE> jobj = of.createDocumentRootRiskCode(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return stabilityTime.
	 * @return stabilityTime
	 */
	public net.ihe.gazelle.medication.IVLTS getStabilityTime() {
		net.ihe.gazelle.medication.IVLTS stabilityTime_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("stabilityTime")){
					stabilityTime_el = (net.ihe.gazelle.medication.IVLTS) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return stabilityTime_el;
				}
			}
		} 

	    return stabilityTime_el;
	}
	
	public void addStabilityTime(net.ihe.gazelle.medication.IVLTS obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.IVLTS> jobj = of.createDocumentRootStabilityTime(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return subjectOf1.
	 * @return subjectOf1
	 */
	public net.ihe.gazelle.medication.COCTMT230100UVSubject2 getSubjectOf1() {
		net.ihe.gazelle.medication.COCTMT230100UVSubject2 subjectOf1_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("subjectOf1")){
					subjectOf1_el = (net.ihe.gazelle.medication.COCTMT230100UVSubject2) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return subjectOf1_el;
				}
			}
		} 

	    return subjectOf1_el;
	}
	
	public void addSubjectOf1(net.ihe.gazelle.medication.COCTMT230100UVSubject2 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.COCTMT230100UVSubject2> jobj = of.createDocumentRootSubjectOf1(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return subjectOf2.
	 * @return subjectOf2
	 */
	public net.ihe.gazelle.medication.COCTMT230100UVSubject1 getSubjectOf2() {
		net.ihe.gazelle.medication.COCTMT230100UVSubject1 subjectOf2_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("subjectOf2")){
					subjectOf2_el = (net.ihe.gazelle.medication.COCTMT230100UVSubject1) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return subjectOf2_el;
				}
			}
		} 

	    return subjectOf2_el;
	}
	
	public void addSubjectOf2(net.ihe.gazelle.medication.COCTMT230100UVSubject1 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.COCTMT230100UVSubject1> jobj = of.createDocumentRootSubjectOf2(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return subjectOf3.
	 * @return subjectOf3
	 */
	public net.ihe.gazelle.medication.COCTMT230100UVSubject22 getSubjectOf3() {
		net.ihe.gazelle.medication.COCTMT230100UVSubject22 subjectOf3_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("subjectOf3")){
					subjectOf3_el = (net.ihe.gazelle.medication.COCTMT230100UVSubject22) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return subjectOf3_el;
				}
			}
		} 

	    return subjectOf3_el;
	}
	
	public void addSubjectOf3(net.ihe.gazelle.medication.COCTMT230100UVSubject22 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.COCTMT230100UVSubject22> jobj = of.createDocumentRootSubjectOf3(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return subjectOf4.
	 * @return subjectOf4
	 */
	public net.ihe.gazelle.medication.COCTMT230100UVSubject3 getSubjectOf4() {
		net.ihe.gazelle.medication.COCTMT230100UVSubject3 subjectOf4_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("subjectOf4")){
					subjectOf4_el = (net.ihe.gazelle.medication.COCTMT230100UVSubject3) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return subjectOf4_el;
				}
			}
		} 

	    return subjectOf4_el;
	}
	
	public void addSubjectOf4(net.ihe.gazelle.medication.COCTMT230100UVSubject3 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.COCTMT230100UVSubject3> jobj = of.createDocumentRootSubjectOf4(obj);
		this.getMixed().add(jobj);
	}
	
	
	/**
	 * Return subjectOf5.
	 * @return subjectOf5
	 */
	public net.ihe.gazelle.medication.COCTMT230100UVSubject7 getSubjectOf5() {
		net.ihe.gazelle.medication.COCTMT230100UVSubject7 subjectOf5_el = null;
			for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof javax.xml.bind.JAXBElement){
				if (((javax.xml.bind.JAXBElement<?>)obj).getName().getLocalPart().equals("subjectOf5")){
					subjectOf5_el = (net.ihe.gazelle.medication.COCTMT230100UVSubject7) ((javax.xml.bind.JAXBElement<?>)obj).getValue();
					return subjectOf5_el;
				}
			}
		} 

	    return subjectOf5_el;
	}
	
	public void addSubjectOf5(net.ihe.gazelle.medication.COCTMT230100UVSubject7 obj){
		ObjectFactory of = new ObjectFactory();
		JAXBElement<net.ihe.gazelle.medication.COCTMT230100UVSubject7> jobj = of.createDocumentRootSubjectOf5(obj);
		this.getMixed().add(jobj);
	}
	
	
	
	public Node get_xmlNodePresentation() {
		if (_xmlNodePresentation == null){
				JAXBContext jc;
				DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
				dbf.setNamespaceAware(true);
				DocumentBuilder db = null;
				Document doc = null;
				try {
					db = dbf.newDocumentBuilder();
					doc = db.newDocument();
				} catch (ParserConfigurationException e1) {}
				try {
					jc = JAXBContext.newInstance("net.ihe.gazelle.medication");
					Marshaller m = jc.createMarshaller();
					m.marshal(this, doc);
					_xmlNodePresentation = doc.getElementsByTagNameNS("urn:epsos-org:ep:medication", "DocumentRoot").item(0);
				} catch (JAXBException e) {
					try{
						db = dbf.newDocumentBuilder();
						_xmlNodePresentation = db.newDocument();
					}
					catch(Exception ee){}
				}
			}
			return _xmlNodePresentation;
	}
	
	public void set_xmlNodePresentation(Node _xmlNodePresentation) {
		this._xmlNodePresentation = _xmlNodePresentation;
	}
	
	
	public List<String> getListStringValues(){
		List<String> res = new ArrayList<String>();
		for(java.io.Serializable obj : this.getMixed()){
			if (obj instanceof String){
				res.add((String)obj);
			}
		} 
		return res;
	}
	

	
	/**
     * validate by a module of validation
     * 
     */
   public static void validateByModule(DocumentRoot documentRoot, String location, ConstraintValidatorModule cvm, List<net.ihe.gazelle.validation.Notification> diagnostic){
   		if (documentRoot != null){
   			cvm.validate(documentRoot, location, diagnostic);
			net.ihe.gazelle.medication.COCTMT230100UVContent.validateByModule(documentRoot.getAsContent(), location + "/asContent", cvm, diagnostic);
			net.ihe.gazelle.medication.COCTMT230100UVDistributedProduct.validateByModule(documentRoot.getAsDistributedProduct(), location + "/asDistributedProduct", cvm, diagnostic);
			net.ihe.gazelle.medication.COCTMT230100UVMedicineManufacturer.validateByModule(documentRoot.getAsMedicineManufacturer(), location + "/asMedicineManufacturer", cvm, diagnostic);
			net.ihe.gazelle.medication.COCTMT230100UVSpecializedKind.validateByModule(documentRoot.getAsSpecializedKind(), location + "/asSpecializedKind", cvm, diagnostic);
			net.ihe.gazelle.medication.ED.validateByModule(documentRoot.getDesc(), location + "/desc", cvm, diagnostic);
			net.ihe.gazelle.medication.IVLTS.validateByModule(documentRoot.getExpirationTime(), location + "/expirationTime", cvm, diagnostic);
			net.ihe.gazelle.medication.CE.validateByModule(documentRoot.getFormCode(), location + "/formCode", cvm, diagnostic);
			net.ihe.gazelle.medication.CE.validateByModule(documentRoot.getHandlingCode(), location + "/handlingCode", cvm, diagnostic);
			net.ihe.gazelle.medication.II.validateByModule(documentRoot.getId(), location + "/id", cvm, diagnostic);
			net.ihe.gazelle.medication.COCTMT230100UVIngredient.validateByModule(documentRoot.getIngredient(), location + "/ingredient", cvm, diagnostic);
			net.ihe.gazelle.medication.COCTMT230100UVMedication.validateByModule(documentRoot.getMedication(), location + "/medication", cvm, diagnostic);
			net.ihe.gazelle.medication.COCTMT230100UVPart.validateByModule(documentRoot.getPart(), location + "/part", cvm, diagnostic);
			net.ihe.gazelle.medication.CE.validateByModule(documentRoot.getRiskCode(), location + "/riskCode", cvm, diagnostic);
			net.ihe.gazelle.medication.IVLTS.validateByModule(documentRoot.getStabilityTime(), location + "/stabilityTime", cvm, diagnostic);
			net.ihe.gazelle.medication.COCTMT230100UVSubject2.validateByModule(documentRoot.getSubjectOf1(), location + "/subjectOf1", cvm, diagnostic);
			net.ihe.gazelle.medication.COCTMT230100UVSubject1.validateByModule(documentRoot.getSubjectOf2(), location + "/subjectOf2", cvm, diagnostic);
			net.ihe.gazelle.medication.COCTMT230100UVSubject22.validateByModule(documentRoot.getSubjectOf3(), location + "/subjectOf3", cvm, diagnostic);
			net.ihe.gazelle.medication.COCTMT230100UVSubject3.validateByModule(documentRoot.getSubjectOf4(), location + "/subjectOf4", cvm, diagnostic);
			net.ihe.gazelle.medication.COCTMT230100UVSubject7.validateByModule(documentRoot.getSubjectOf5(), location + "/subjectOf5", cvm, diagnostic);
    	}
    }

}